
import java.awt.*; import javax.swing.*; import java.io.*; import java.util.*;

/*
	MainPanel.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Rendering the map.
	Allowed Dependencies: Shiny_Sword.java
*/

public class MainPanel extends JPanel 
{
    private WalkMap cur_map;
    
    public MainPanel(WalkMap cur_map, int x, int y) {
    	//X and Y are left in so that a initial camerapoint can be picked!
    	this.cur_map = cur_map;
    	
    	this.setBackground(new Color((float) 0.0, (float) 0.0, (float) 0.0));

		//Camerawork code.
    	if(x<160) { Buffer.setCX(0); }
    	else if(x<cur_map.getWidth()-160) {
    	  Buffer.setCX(cur_map.getWidth()-320);
    	}
    	else {
    	  Buffer.setCX(x-160);	
    	}    
    	if(y<120) { Buffer.setCY(0); }
    	else if(y<cur_map.getHeight()-120) {
    	  Buffer.setCY(cur_map.getHeight()-240);
    	}
    	else {
    	  Buffer.setCY(y-120);	
    	}   	
    	
        //Don't forget to set the entity itself ;).
    	Buffer.SX=x;
    	Buffer.SY=y;
    	}
    
    public void	Update(int x,int y) {
    	this.cur_map = Buffer.getCurMap(); //necessary?
    	
    	//Camerawork code.
    	if(x<180) { Buffer.setCX(0); }
    	else if(x<(cur_map.getWidth()*24)-180) {
    	  Buffer.setCX(x-180);
    	}
    	else {
    	  Buffer.setCX((cur_map.getWidth()*24)-360);	
    	}    
    	if(y<120) { Buffer.setCY(0); }
    	else if(y<(cur_map.getHeight()*24)-120) {
    	  Buffer.setCY(y-120);
    	}
    	else {
    	  Buffer.setCY((cur_map.getHeight()*24)-240);	
    	}   	
    	
        //Minor detail: Don't forget to move the entity itself ;).
    	Buffer.SX=x;
    	Buffer.SY=y;
    	}
    
    public void paintComponent(Graphics g) {

        super.paintComponent(g);

        Lib_Image.renderMap(cur_map,g,this,Buffer.getCX(),Buffer.getCY(),360,240,0);
        Lib_Image.renderMap(cur_map,g,this,Buffer.getCX(),Buffer.getCY(),360,240,1);
        g.drawImage(Buffer.getSprite(0).getFrame(Buffer.SF),Buffer.SX-Buffer.getCX(),Buffer.SY-Buffer.getCY(),this);
        Lib_Image.renderMap(cur_map,g,this,Buffer.getCX(),Buffer.getCY(),360,240,2);
    }

}