import java.awt.*; import javax.swing.*; import java.awt.event.*; 
import javax.swing.colorchooser.*;

/*
	TileDialog.java
  	(c)1999-2003 SSC Development Team
	Functions: 
	-Managing the Tile Editor GUI.
	Allowed Dependencies: Buffer.java, Tileset.java
*/

public class TileDialog extends JDialog implements ActionListener, WindowListener
{
	JButton next, previous, addt, imp, newts;
	JLabel current, ntlabel;
	JSpinner nexttile;
	JTextField imptiles;
	TileViewPanel tile;
	Container c = this.getContentPane();
	Palette chooser;
	
	public TileDialog(Frame owner, String title, int curtile)
	{
	super(owner,title);
	this.setSize(470, 300);
	
	//interface elements
	addt = new JButton("add tile");
	addt.setActionCommand("addtile");
	imp = new JButton("import from image");
	imp.setActionCommand("imptile");
	newts = new JButton("new set from image");
	newts.setActionCommand("newtileset");	
	next = new JButton("next");
	next.setActionCommand("next");
	current = new JLabel("Current Tile = "+Buffer.getCurTile());
	previous = new JButton("previous");
	previous.setActionCommand("previous");
   	
	nexttile = new JSpinner();
	nexttile.setValue(new Integer(Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).getNextTile()));
	ntlabel = new JLabel("Next Frame = ");
	chooser = new Palette();
	tile = new TileViewPanel();
	imptiles = new JTextField(35);
	
	//interface positioning
	c.setLayout(null);
	c.add(current);
	c.add(previous);
	c.add(next);
	c.add(tile);
	c.add(nexttile);
	c.add(ntlabel);
	c.add(chooser);
	c.add(addt);
	c.add(imptiles);
	c.add(imp);
	c.add(newts);
	
	current.setBounds(255,5,100,20);
	previous.setBounds(255,25,85,20);
	next.setBounds(340,25,85,20);
	tile.setBounds(5,5,240,240);
	ntlabel.setBounds(255,65,85,20);
	nexttile.setBounds(340,65,50,20);
	chooser.setBounds(255,85,200,100);
	addt.setBounds(255,200,85,20);
	newts.setBounds(255,225,170,20);
	imptiles.setBounds(5,250,240,20);
	imp.setBounds(255,250,170,20);
	
	//Add Listeners
	previous.addActionListener(this);
	next.addActionListener(this);
	addt.addActionListener(this);
	this.addWindowListener(this);
	imp.addActionListener(this);
	newts.addActionListener(this);
	
	this.show();	
	}

	public void actionPerformed(ActionEvent e)
	{
	if("imptile".equals(e.getActionCommand()))
		{
			
		String filename = imptiles.getText();
		System.out.println("The file is: "+filename);
		if(filename != "") {	
			Buffer.getCurMap().setTileset(Lib_Util.ImportIntoTileset(filename,Buffer.getCurMap().getTileset()));
			Buffer.initializeTiles(Buffer.getCurMap());	
			}
		}
	if("newtileset".equals(e.getActionCommand())) //TODO: Implement in GUI!
		{	
		String filename = imptiles.getText();
		System.out.println("The file is: "+filename);
		if(filename != "") {	
			Buffer.getCurMap().setTileset(new Tileset(filename));
			Buffer.initializeTiles(Buffer.getCurMap());	
			}		
		}
	if("addtile".equals(e.getActionCommand()))
		{
		Buffer.getCurMap().getTileset().addTile();
		Buffer.addTile();
		System.out.println(Buffer.getCurMap().getTileset().getLength());	
		}	
	if("previous".equals(e.getActionCommand()))
		{
		if(Buffer.getCurTile() > 0) 
			{ 
			Integer i = (Integer) nexttile.getValue();
			int j = i.intValue();
			Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).setNextTile(j);
			
			Buffer.setCurTile(Buffer.getCurTile() - 1);
			current.setText("Current Tile = "+Buffer.getCurTile());
			nexttile.setValue(new Integer(Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).getNextTile()));
			tile.repaint();
			}	
		}	
	if("next".equals(e.getActionCommand()))
		{
		if(Buffer.getCurTile() < (Buffer.getCurMap().getTileset().getLength() - 1)) 
			{ 
			Integer i = (Integer) nexttile.getValue();
			int j = i.intValue();
			Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).setNextTile(j);
			
			Buffer.setCurTile(Buffer.getCurTile() + 1);
			current.setText("Current Tile = "+Buffer.getCurTile());
			nexttile.setValue(new Integer(Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).getNextTile()));
			tile.repaint();
			}		
		}	
	}
	
	public void windowClosing(WindowEvent e) {
			Integer i = (Integer) nexttile.getValue();
			int j = i.intValue();
			Buffer.getCurMap().getTileset().getTile(Buffer.getCurTile()).setNextTile(j);
			this.dispose();
    }

    public void windowClosed(WindowEvent e) {   }

    public void windowOpened(WindowEvent e) {	}

    public void windowIconified(WindowEvent e) {    }

    public void windowDeiconified(WindowEvent e) {    }

    public void windowActivated(WindowEvent e) {    }

    public void windowDeactivated(WindowEvent e) {    }
}