import java.awt.*; import javax.swing.*; import java.io.*; import java.util.*; 
import java.awt.event.*;

/*
	TileViewPanel.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Rendering the tile viewer.
	Allowed Dependencies: Any
*/

public class TileViewPanel extends JPanel implements MouseListener, MouseMotionListener
{
	Graphics g;


    public void paintComponent(Graphics g) {
		this.removeMouseListener(this);
		this.g = g;
		
        super.paintComponent(g);

		g.fillRect(0,0,240,240);
  		g.drawImage(Buffer.getTile(Buffer.getCurTile()),0,0,240,240,this);
  		
  		this.addMouseListener(this);
  		this.addMouseMotionListener(this);
    }	
    
	public void mousePressed(MouseEvent e) {
        int x = (e.getX()/10);
        int y = (e.getY()/10);
               
        //Update the tile in the buffer
        Buffer.getTile(Buffer.getCurTile()).setRGB(x,y,Buffer.getCurColor().getRGB());
        
        //Update the tile in the data structure
        Buffer.getCurMap().getTileset().setTile(Buffer.getCurTile(),new Tile(Buffer.getTile(Buffer.getCurTile())));
        
        this.repaint();
    }

    public void mouseReleased(MouseEvent e) {    }

    public void mouseEntered(MouseEvent e) {    }

    public void mouseExited(MouseEvent e) {    }

    public void mouseClicked(MouseEvent e) {	}
    
    public void mouseDragged(MouseEvent e) {   	
  		int x = (e.getX()/10);
        int y = (e.getY()/10);  
		
		if(x>=0 && y>=0 && x<24 && y<24) {
    	if(Buffer.getTile(Buffer.getCurTile()).getRGB(x,y) != Buffer.getCurColor().getRGB()) {
   		    
   		    //Update the tile in the buffer
        	Buffer.getTile(Buffer.getCurTile()).setRGB(x,y,Buffer.getCurColor().getRGB());
        
        	//Update the tile in the data structure
        	Buffer.getCurMap().getTileset().setTile(Buffer.getCurTile(),new Tile(Buffer.getTile(Buffer.getCurTile())));
        
        	this.repaint();    		
    	} }
    }	
    
    public void mouseMoved(MouseEvent e)  {	}
}